/*
 * Created on Apr 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gov.nasa.du.schemavalidator;

/**
 * @author mrabi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.border.EmptyBorder;
import javax.swing.plaf.metal.MetalIconFactory;

public class LogWindow extends JList {
	public static final int INFO = 0;
	public static final int ERROR = 1;
	public static final int WARNING = 2;
	public static final int OK = 3;
	public static final int FATAL_ERROR = 4;
	public static final int ALL = 5;

	public static Icon[] icons =
		new Icon[] {
			new ImageIcon("status_info_small.gif"),
			new ImageIcon("status_error_small.gif"),
			new ImageIcon("status_warning_small.gif"),
			new ImageIcon("status_ok_small.gif"),
			new ImageIcon("status_error_small.gif")};

	public LogWindow() {
		super();
		setModel(new DefaultListModel());

		// set "home" icon
		Icon icon = MetalIconFactory.getFileChooserHomeFolderIcon();

		setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		setBorder(new EmptyBorder(0, 4, 0, 0));
		addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				int index = locationToIndex(e.getPoint());
				if (index >= 0 && index < getModel().getSize()) {
					LogItem item = (LogItem) getModel().getElementAt(index);
					//item.setSelected(! item.isSelected());
					Rectangle rect = getCellBounds(index, index);
					repaint(rect);
					if (e.getClickCount() == 2
						&& item.getExtendedInfo() != null) {
						JOptionPane.showMessageDialog(
							SchemaValidatorGUI.frame,
							item.getExtendedInfo(),
							"Extended log information",
							JOptionPane.INFORMATION_MESSAGE);

					}
				}
			}
		});

	}

	public void addEntry(LogItem item) {
		DefaultListModel model = (DefaultListModel) getModel();
		model.addElement(item);
		ensureIndexIsVisible(model.size() - 1);
	}

	public void clearList() {
		DefaultListModel model = (DefaultListModel) getModel();
		model.removeAllElements();
	}

	 
	public void saveList(String filename) {
		System.out.println("saving to file" + filename);
		DefaultListModel lsm = (DefaultListModel) getModel();
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(filename));

			for (int i = 0; i < lsm.getSize(); i++) {
				out.write(i + ":");
				out.write(lsm.getElementAt(i).toString());
				out.write('\n');
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}

class LogItem {
	private String str, extendedInfo;
	private int iconType;

	public LogItem(String str, int iconType, String extendedInfo) {
		this.str = str;
		this.extendedInfo = extendedInfo;
		this.iconType = iconType;
	}

	public String toString() {
		return str;
	}

	public String getExtendedInfo() {
		return extendedInfo;
	}

	public Icon getIcon() {
		return LogWindow.icons[iconType];
	}
	
	public int getIconType() {
		return iconType;
	}
	
}
