package gov.nasa.du.schemavalidator;
import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDesktopPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.WindowConstants;

/**
 * Title:        ECS Schema Validation Tool GUI Interface
 * Description:  This is project provides a Graphical User Interface to the ECS Schema Validation tool.
 * Copyright:    Copyright (c) 2004
 * Company: GST, Inc.
 * @author Muhammad Rabi
 * @version 1.0
 */

public class SchemaValidatorFrame extends JFrame {
	static final Integer HELPLAYER = new Integer(7);
	static private final String newline = "\n";
	static String xml_input_file = "C:\\scratch\\collection_sample.xml";
	// "sample.xml";
	static String log_output_file = "log.txt";
	static JDesktopPane desktop = new JDesktopPane();
	private static SchemaValidator validator = null;

	JPanel contentPane;
	JMenuBar jMenuBar1 = new JMenuBar();
	JMenu jMenuFile = new JMenu();
	JMenuItem jMenuFileExit = new JMenuItem();
	JMenu jMenuHelp = new JMenu();
	JMenuItem jMenuHelpAbout = new JMenuItem();
	JMenuItem jMenuHelpContents = new JMenuItem();
	JToolBar jToolBar = new JToolBar();

	JButton jButton1 = new JButton();
	JButton jButton2 = new JButton();
	JButton jSaveLog = new JButton();
	JButton jShowStats = new JButton();

	ImageIcon image1;
	ImageIcon image2;
	ImageIcon image3;
	ImageIcon image4;
	ImageIcon image5;
	ImageIcon execute;

	BorderLayout borderLayout1 = new BorderLayout();
	//Create the log first, because the action listeners
	//need to refer to it.

	//Create a file chooser
	final JFileChooser fc = new JFileChooser();
	final JFileChooser sfc = new JFileChooser();
	JPanel jPanel1 = new JPanel(new FlowLayout());

	JLabel jLabel2 = new JLabel();
	JLabel jLabel1 = new JLabel();

	JTextField jTextField2 = new JTextField();

	// Log lists
	LogWindow logList;

	//JScrollPane jScrollPane1 = new JScrollPane(log);
	// JScrollPane jScrollPane1 = new JScrollPane(logList);

	JLabel jLabel3 = new JLabel();

	JTextField jTextField3 = new JTextField();
	JTextField jTextField4 = new JTextField();

	JLabel jLabel4 = new JLabel();
	JLabel jLabel5 = new JLabel();

	JButton jButton3 = new JButton();

	JComboBox jFilter = new JComboBox();

	JScrollPane logScrollPane = null;

	/**Construct the frame*/
	public SchemaValidatorFrame() {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**Component initialization*/
	private void jbInit() throws Exception {
		image1 =
			new ImageIcon(
				SchemaValidatorFrame.class.getResource("openFile.gif"));
		image2 =
			new ImageIcon(
				SchemaValidatorFrame.class.getResource("closeFile.gif"));
		image3 =
			new ImageIcon(SchemaValidatorFrame.class.getResource("help.gif"));
		image4 =
			new ImageIcon(
				SchemaValidatorFrame.class.getResource("viewstats.gif"));
		image5 =
			new ImageIcon(
				SchemaValidatorFrame.class.getResource("filview2.gif"));
		execute =
			new ImageIcon(
				SchemaValidatorFrame.class.getResource("execute.gif"));

		contentPane = (JPanel) this.getContentPane();

		contentPane.setLayout(new FlowLayout());

		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.setSize(new Dimension(620, 375));
		this.setTitle("ECS Schema Validation Tool");
		jMenuFile.setText("File");
		jMenuFileExit.setText("Exit");
		jMenuFileExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuFileExit_actionPerformed(e);
			}
		});
		jMenuHelp.setText("Help");
		jMenuHelpAbout.setText("About");
		jMenuHelpContents.setText("Help Contents");
		jMenuHelpAbout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuHelpAbout_actionPerformed(e);
			}
		});
		jMenuHelpContents.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jMenuHelpContents_actionPerformed(e);
			}
		});
		jButton1.setMnemonic('0');
		jButton1.setText("Open");
		jButton1.setDoubleBuffered(true);
		jButton1.setToolTipText("Open ECS XML File");
		jButton1.setDisabledIcon(null);
		jButton1.setIcon(image1);

		jButton2.setText("Validate");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButton2_actionPerformed(e);
			}
		});
		jButton2.setMaximumSize(new Dimension(125, 27));
		jButton2.setMinimumSize(new Dimension(110, 27));
		jButton2.setToolTipText(" Validate XML File");

		jButton2.setIcon(
			new ImageIcon(SchemaValidatorFrame.class.getResource("check.gif")));
		jButton2.setPreferredSize(new Dimension(110, 27));

		jButton2.setMnemonic('0');

		jSaveLog.setMnemonic('S');
		jSaveLog.setText("Save Log As");
		jSaveLog.setDoubleBuffered(true);
		jSaveLog.setToolTipText("Save Console log to a file");
		jSaveLog.setDisabledIcon(null);
		jSaveLog.setIcon(image2);

		jShowStats.setMnemonic('T');
		jShowStats.setText("Show Statistics");
		jShowStats.setDoubleBuffered(true);
		jShowStats.setToolTipText("Save Console log to a file");
		jShowStats.setDisabledIcon(null);
		jShowStats.setIcon(image4);
		jShowStats.setPreferredSize(new Dimension(155, 27));
		//    jToolBar.setToolTipText("ECS Schema Validation Options");

		jPanel1.setForeground(Color.red);

		jLabel2.setText("Cosole Log");
		jLabel1.setToolTipText("");

		jTextField3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jTextField3_actionPerformed(e);
			}
		});
		jTextField4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jTextField4_actionPerformed(e);
			}
		});

		jFilter.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jFilter_actionPerformed(e);
			}
		});

		jFilter.setToolTipText("Select a filter...");
		jFilter.setPreferredSize(new Dimension(131, 27));
		jFilter.addItem(makeObj("All"));
		jFilter.addItem(makeObj("Info"));
		jFilter.addItem(makeObj("Warning"));
		jFilter.addItem(makeObj("Error"));
		jFilter.addItem(makeObj("Fatal Error"));

		// jLabel3.setToolTipText("");
		//jLabel3.setText("ODL Group");
		jTextField3.setPreferredSize(new Dimension(300, 25));
		jTextField3.setToolTipText(
			"Insert XML input file name including"
				+ " path information if needed...");
		jTextField3.setText(xml_input_file);

		jTextField4.setPreferredSize(new Dimension(163, 21));

		jTextField4.setToolTipText(
			"Insert LOG output file name including"
				+ " path information if needed...");
		jTextField4.setText(log_output_file);

		//   jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		//  jScrollPane1.setBorder(BorderFactory.createLoweredBevelBorder());
		//  jScrollPane1.setMinimumSize(new Dimension(600, 1000));
		// jScrollPane1.setNextFocusableComponent(this);

		jLabel4.setToolTipText("");
		jLabel4.setText("XML File ");

		jLabel5.setToolTipText("Filter log by ...");
		jLabel5.setText("Filter/Show ");

		jButton3.setToolTipText("");
		jButton3.setIcon(
			new ImageIcon(SchemaValidatorFrame.class.getResource("clear.gif")));
		jButton3.setText("Clear Log");
		jButton3.setPreferredSize(new Dimension(110, 27));

		jMenuFile.add(jMenuFileExit);
		jMenuHelp.add(jMenuHelpContents);
		jMenuHelp.addSeparator();
		jMenuHelp.add(jMenuHelpAbout);
		jMenuBar1.add(jMenuFile);
		jMenuBar1.add(jMenuHelp);
		this.setJMenuBar(jMenuBar1);
		// initial log area
		logList = new LogWindow();

		logScrollPane = new JScrollPane(logList) {
			public Dimension getPreferredSize() {
				Dimension d = super.getPreferredSize();
				d.width = 550; //Math.min(d.width, 500);
				d.height = 220; //Math.min(d.height, 500);
				return d;
			}
		};

		logScrollPane.setBorder(BorderFactory.createEtchedBorder());
		UIHelper.initLog(logList);

		//log.setDoubleBuffered(true);

		contentPane.add(jLabel4, null);
		contentPane.add(jTextField3, null);
		contentPane.add(jButton1, null);

		// jToolBar.add(jLabel5, null);
		// jToolBar.add(jTextField4, null);

		contentPane.add(jButton2, null);
		contentPane.add(jLabel3, null);

		// contentPane.add(jLabel1, null);
		//  contentPane.add(jTextField2, null);
		//   contentPane.add(jButton4, null);

		contentPane.add(jPanel1);
		contentPane.add(jToolBar, null);
		//  contentPane.add(jScrollPane1);
		contentPane.add(logScrollPane);

		// logScrollPane.getViewport().add(jPanel1, null);

		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int returnVal = fc.showOpenDialog(SchemaValidatorFrame.this);

				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();
					//this is where a real application would open the file.
					UIHelper.logInfo(
						"Opening: " + file.getPath() + "." + newline,
						"Opening: " + file.getPath() + "." + newline);

					jTextField3.setText(file.getPath());
					if (file.exists() && file.isFile()) {
						xml_input_file = file.getPath();
					} else {
						UIHelper.logError(
							"Error opening file \"" + file.getName() + "\"...",
							"Error opening file \"" + file.getName() + "\"...");
					}
				} else {
					UIHelper.logInfo(
						"Open command canceled by user",
						"Open command cancelled by user. Extended INFO...");
				}
				jButton1_actionPerformed(e);
			}
		});

		jSaveLog.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int returnVal = sfc.showOpenDialog(SchemaValidatorFrame.this);

				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = sfc.getSelectedFile();
					//this is where a real application would open the file.
					UIHelper.logInfo(
						"Saving: " + file.getPath() + "." + newline,
						"Saving: " + file.getPath() + "." + newline);
					log_output_file = file.getPath();
				} else {
					UIHelper.logInfo(
						"Save log cancelled by user." + newline,
						"Save log cancelled by user." + newline);
				}
				jSaveLog_actionPerformed(e);
			}
		});

		jShowStats.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				UIHelper.logInfo(
					"Showing Statistics..." + newline,
					"Showing Statistics..." + newline);

				jShowStats_actionPerformed(e);
			}
		});

		// JPanel jp = new JPanel(new BorderLayout());

		//  contentPane.add(jp, null);
		contentPane.add(jLabel5, null);
		contentPane.add(jFilter, null);
		contentPane.add(jShowStats, null);
		contentPane.add(jButton3, null);
		contentPane.add(jSaveLog, null);

		jButton3.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButton3_actionPerformed(e);
			}
		});

	}
	/**File | Exit action performed*/
	public void jMenuFileExit_actionPerformed(ActionEvent e) {
		System.exit(0);
	}
	/**Help | About action performed*/
	public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
		SchemaValidator_AboutBox dlg = new SchemaValidator_AboutBox(this);
		Dimension dlgSize = dlg.getPreferredSize();
		Dimension frmSize = getSize();
		Point loc = getLocation();
		dlg.setLocation(
			(frmSize.width - dlgSize.width) / 2 + loc.x,
			(frmSize.height - dlgSize.height) / 2 + loc.y);
		dlg.setModal(true);
		dlg.show();
	}
	/**Help | Contents Help action performed*/
	public void jMenuHelpContents_actionPerformed(ActionEvent e) {
		//Frame1_ContentsHtmlBox dlg = new Frame1_ContentsHtmlBox(this);
		SchemaValidatorHelp dlg = new SchemaValidatorHelp(this);
		Dimension dlgSize = dlg.getPreferredSize();
		Dimension frmSize = getSize();
		Point loc = getLocation();
		dlg.setLocation(loc.x / 2 + 100, loc.y / 2);
		dlg.setModal(true);
		dlg.show();
	}

	/**Overridden so we can exit when window is closed*/
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			jMenuFileExit_actionPerformed(null);
		}
	}

	void jButton1_actionPerformed(ActionEvent e) {

	}

	void jSaveLog_actionPerformed(ActionEvent e) {
		logList.saveList(log_output_file);
	}

	void jButton4_actionPerformed(ActionEvent e) {

	}
	void jFilter_actionPerformed(ActionEvent e) {
		LogWindow filterList = null;
		switch (jFilter.getSelectedIndex()) {
			case 0 :
				if (logList != null) {
					filterList = UIHelper.getFilterList(LogWindow.ALL);

				}
				break;
			case 1 :
				if (logList != null) {
					filterList = UIHelper.getFilterList(LogWindow.INFO);
				}
				break;
			case 2 :
				if (logList != null) {
					filterList = UIHelper.getFilterList(LogWindow.WARNING);
				}
				break;
			case 3 :
				if (logList != null) {
					filterList = UIHelper.getFilterList(LogWindow.ERROR);
				}
				break;
			case 4 :

				if (logList != null) {
					filterList = UIHelper.getFilterList(LogWindow.FATAL_ERROR);
				}
				break;
		}
		if (logList != null) {

			SchemaValidatorFilterFrame dlg =
				new SchemaValidatorFilterFrame(this, filterList);
			Dimension dlgSize = dlg.getPreferredSize();
			Dimension frmSize = getSize();
			Point loc = getLocation();
			dlg.setLocation(loc.x / 2 + 100, loc.y / 2);
			dlg.setModal(true);
			dlg.show();
		}

	}

	void jButton2_actionPerformed(ActionEvent e) {

		xml_input_file = jTextField3.getText();
		UIHelper.logInfo(
			"Validating " + xml_input_file + "..." + newline,
			"Validating " + xml_input_file + "..." + newline);

		validator = new SchemaValidator();
		SchemaValidatorController svc =
			new SchemaValidatorController(validator, xml_input_file,true);
		svc.validateFile();

	}
	void jButton3_actionPerformed(ActionEvent e) {
		/**
		 * clear console log
		 */
		logList.clearList();
		UIHelper.clearLogBuffer();
		UIHelper.initLog(logList);
		// logList.repaint();
	}

	void jShowStats_actionPerformed(ActionEvent e) {
		/**
		 * showing stats
		 */
		if (validator == null) {
			JOptionPane.showMessageDialog(
				SchemaValidatorGUI.frame,
				"Please select an XML file and click on Validate to get statistics"
					+ newline,
				"Statistics from XML Parsing...",
				JOptionPane.INFORMATION_MESSAGE);
		} else {

			JOptionPane.showMessageDialog(
				SchemaValidatorGUI.frame,
				"Parsing statistics for "
					+ xml_input_file
					+ newline
					+ "---------------------------------------"
					+ "---------------------------------------"
					+ newline
					+ "Number of Warnings:"
					+ SchemaValidatorController.warnExceptions.size()
					+ newline
					+ "Number of Errors:"
					+ SchemaValidatorController.errorExceptions.size()
					+ newline
					+ "Number of Fatal Errors:"
					+ SchemaValidatorController.fatalErrorExceptions.size()
					+ newline,
				"XML Parsing Statistics...",
				JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private Object makeObj(final String item) {
		return new Object() {
			public String toString() {
				return item;
			}
		};
	}

	void jTextField3_actionPerformed(ActionEvent e) {
		xml_input_file = jTextField3.getText();
		UIHelper.logInfo(
			"XML Input File: " + xml_input_file + newline,
			"XML Input File: " + xml_input_file + newline);
	}
	void jTextField4_actionPerformed(ActionEvent e) {
		log_output_file = jTextField4.getText();
		UIHelper.logInfo(
			"LOG Output File: " + log_output_file + newline,
			"LOG Output File: " + log_output_file + newline);
	}

}
