/*
 * Created on Apr 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gov.nasa.du.schemavalidator;

import java.util.ArrayList;
import java.util.Collection;

/**
 * @author mrabi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SchemaValidatorController {

	/**
	 * 
	 */

	private static SchemaValidator schemaValidator;
	private static String xmlFile;
	private static boolean cancelledByUser;
	private static boolean success;
	private static boolean gui_flag=true;

	private static SchemaValidatorProgressDialog progressDialog;

	public static Collection warnExceptions;
	public static Collection errorExceptions;
	public static Collection fatalErrorExceptions;

	public static boolean isSuccess() {
		return success;
	}

	public static boolean isUseCancelled() {
		return cancelledByUser;
	}

	public SchemaValidatorController(SchemaValidator sv, String xml_file, boolean guiFlag) {
		super();
		schemaValidator = sv;
		xmlFile = xml_file;
		gui_flag = guiFlag;
		cancelledByUser = false;
		warnExceptions = new ArrayList();
		errorExceptions = new ArrayList();
		fatalErrorExceptions = new ArrayList();
	}
	/**
	 * Worker method for the thread.
	 *
	 */
	public static void work() {
		if (gui_flag) { 
		progressDialog = new SchemaValidatorProgressDialog();
		startAsyncWork();
		progressDialog.show();
		if (progressDialog.isActionCancelledByUser()) {
			cancelledByUser = true;
			logSummary();
			progressDialog = null;
		}
		} else {
			validate();
		}
		//progressDialog = null;
	}

	/*
	 * This method is called by the RegistryProgressDialog
	 */
	public static void startAsyncWork() {
		/* Invoking start() on the SwingWorker causes a new Thread
		 * to be created that will call construct(), and then
		 * finished().  Note that finished() is called even if
		 * the worker is interrupted because we catch the
		 * InterruptedException in doWork().
		 */
		SwingWorker worker = new SwingWorker() {
			public Object construct() {
				asyncWork();
				return null;
			}
			public void finished() {
				if (progressDialog != null) {
					progressDialog.dispose();
					logSummary();
				}
			}
		};
		worker.start();
	}

	/**
	 * Logs action summary.
	 *
	 */
	private static void logSummary() {
		if (cancelledByUser) {
			UIHelper.logInfo("Action was cancelled by user", null);

		}
	}

	/**
	 * Called by startAsyncWork
	 *
	 */
	private static void asyncWork() {
		validate();

	}

	/**
	 *  Read details of the results.
	 *
	 */
	private static void validate() {
		try {
			schemaValidator.validateFile(xmlFile);
		} catch (Exception e) {

		}
	}

	public static void validateFile() {
		work();
	}
}
