package gov.nasa.du.schemavalidator;
import javax.swing.UIManager;
import java.awt.*;

/**
 * Title:        SchemaValidator Tool GUI Interface
 * Description:  This is project provides a Graphical User Interface to the Schema Validation tool. 
 * Copyright:    Copyright (c) 2004
 * Company: GST
 * @author Muhammad Rabi
 * @version 1.0
 */

public class SchemaValidatorGUI {
  boolean packFrame = false;
  public static SchemaValidatorFrame frame = null;
  /**Construct the application*/
  public SchemaValidatorGUI() {
     frame = new SchemaValidatorFrame();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }
  /**Main method*/
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new SchemaValidatorGUI();
  }
}
