/*
 * Created on Apr 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gov.nasa.du.schemavalidator;

/**
 * @author mrabi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JToolBar;

/**
 * @author Alex Holmes
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class UIHelper {
	public static Collection initLogBuffer = new ArrayList();
	public static Collection logBuffer = new ArrayList();
	public static LogWindow logWindow;

	public static void initLog(LogWindow logWindow) {
		UIHelper.logWindow = logWindow;
		Iterator iter = initLogBuffer.iterator();
		while (iter.hasNext()) {
			log((LogItem) iter.next());
		}
	}

    public static void clearLogBuffer(){
    	 logBuffer.clear();
    }
	public static void center(Component c) {
		center(c, c.getSize());
	}

	public static void center(Component c, Dimension me) {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		c.setLocation(
			screenSize.width / 2 - me.width / 2,
			screenSize.height / 2 - me.height / 2);
	}

	public static void add(
		Container ct,
		JComponent c,
		GridBagLayout gbl,
		GridBagConstraints gbc,
		int x,
		int y,
		int w,
		int h) {

		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gbl.setConstraints(c, gbc);
		ct.add(c);
	}

	public static LogWindow getFilterList(int type) {
		LogWindow lw = new LogWindow();
		
		Iterator iter = logBuffer.iterator();
		while (iter.hasNext()) {
			LogItem li = (LogItem) iter.next();
			if(type == LogWindow.ALL) {
				lw.addEntry(li);
			} else {
				if(li.getIconType() == type){
				lw.addEntry(li);
				}
			}	
		}
		return lw;
	}

	public static void logInfo(String msg, String extendedInfo) {
		log(LogWindow.INFO, "[Info] " + msg, "[Info] " + extendedInfo);
	}

	public static void logError(String msg, String extendedInfo) {
		log(LogWindow.ERROR, "[Error] " + msg, "[Error] " + extendedInfo);
	}

	public static void logFatalError(String msg, String extendedInfo) {
		log(
			LogWindow.FATAL_ERROR,
			"[Fatal Error] " + msg,
			"[Fatal Error] " + extendedInfo);
	}

	public static void logWarning(String msg, String extendedInfo) {
		log(LogWindow.WARNING, "[Warning] " + msg, "[Warning] " + extendedInfo);
	}

	public static void logSuccess(String msg, String extendedInfo) {
		log(LogWindow.OK, "[Ok] " + msg, "[Ok] " + extendedInfo);
	}

	private static void log(int type, String msg, String extendedInfo) {
		LogItem li = new LogItem(msg, type, extendedInfo);
		log(li);
	}

	private static void log(LogItem logItem) {
		if (logWindow != null) {
			logWindow.addEntry(logItem);
			logBuffer.add(logItem);
		} else {
			initLogBuffer.add(logItem);
			logBuffer.add(logItem);
		}
		
	}

	// Helper method to create new toolbar buttons
	public static JButton addToolbarButton(
		JToolBar toolBar,
		boolean useImage,
		boolean displayDropDown,
		String buttonText,
		String unselectedButtonImage,
		String toolHelp,
		String actionCmdString,
		ActionListener listener) {
		JButton b;

		// Create a new button
		if (useImage) {
			b = new JButton();
			b.setIcon(new ImageIcon(unselectedButtonImage));
			//b.setRolloverIcon(new ImageIcon(rolloverButtonImage));
			//b.setRolloverEnabled(true);
			//b.setBorder(BorderFactory.createEmptyBorder());
			b.setBorderPainted(false);
			b.setFocusPainted(false);
			b.addMouseListener(new ToolbarMouseEventListener(b));
		} else {
			b = (JButton) toolBar.add(new JButton());
		}

		// Add the button to the toolbar
		toolBar.add(b);

		if (displayDropDown) {
			JButton dd = new JButton();
			dd.setIcon(new ImageIcon("images/dropdown.gif"));
			dd.setBorderPainted(false);
			dd.setFocusPainted(false);
			dd.addMouseListener(new ToolbarMouseEventListener(dd, b));
			toolBar.add(dd);
		}

		// Add optional button text
		if (buttonText != null)
			b.setText(buttonText);
		else {
			// Only a graphic, so make the button smaller
			b.setMargin(new Insets(0, 0, 0, 0));
		}

		// Add optional tooltip help
		if (toolHelp != null)
			b.setToolTipText(toolHelp);

		// Make sure this button sends a message when the user clicks it
		b.setActionCommand(actionCmdString);
		b.addActionListener(listener);
		b.setFont(b.getFont().deriveFont(Font.PLAIN));

		return b;
	}

}

class ToolbarMouseEventListener implements MouseListener {
	JButton button, masterButton;
	ToolbarMouseEventListener(JButton button) {
		this.button = button;
	}
	ToolbarMouseEventListener(JButton button, JButton masterButton) {
		this.button = button;
		this.masterButton = masterButton;
	}
	public void mouseClicked(MouseEvent ev) {
	}
	public void mouseEntered(MouseEvent ev) {
		if (button.isEnabled()) {
			button.setBorderPainted(true);
			if (masterButton != null) {
				masterButton.setBorderPainted(true);
			}
		}
	}
	public void mouseExited(MouseEvent ev) {
		button.setBorderPainted(false);
		if (masterButton != null) {
			masterButton.setBorderPainted(false);
		}
	}
	public void mousePressed(MouseEvent ev) {
	}
	public void mouseReleased(MouseEvent ev) {
	}
}